(in-package "CAVSTUF")

(progn    ;; Load the toy library
  (setf *print-level* 3)
  (set-current-mlib-to 'CyHxamide-0.2)
  )
(progn    ;; Grow a sample tree
  (init-tree "Cubane-frame")
  (grow-a-tree)
  )
(progn    ;; Dump tree out in file
 ; (multiple-value-setq (actual-tree tree-symbol) (get-current-tree))
  (setf INCLUDE-FRAME t)
  (setf NO-INCLUDE-FRAME nil)
  (setf raw-format (dump-tree (get-current-tree) INCLUDE-FRAME))
  (write-pdb-file raw-format
                  "newtree.pdb"
            ;;;      "newtreeweird2.gcl.pdb"
             ;;;     "14-helix.pdb"
                  )
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;;    this file is part of CavityStuffer - a molecular polymer design tool
;;;                         -------------
;;; copyright (c) 1993 by Institute for Molecular Manufacturing, Palo Alto, CA
;;; copyright (c) 1994 and beyond: M. Krummenacker (KR) kr@n-a-n-o.com
;;;
;;; -This program is free software; you can redistribute it and/or modify
;;;   it under the terms of the GNU General Public License as published by
;;;   the Free Software Foundation.
;;; -This program is distributed in the hope that it will be useful, but WITHOUT
;;;   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;;;   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU GPL for more details.
;;; -You should have received a copy of the GNU General Public License along with
;;;   this program (the file "COPYING-2.0"); if not, write to the Free Software
;;;   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;; Please IGNORE most of the random junk below :-) ;;;;;;;
#|
;;;kr97-01-23
;;; let's try some of this 14-helix stuff.
(progn
  ;;;(init-tree "CyHxbetaA")
  
  
  (setf 14-helix-tree
        '((FRAME "CyHxbetaB")
          (("CyHxbetaB->amide2"
            (NAVEL
             ("amide->CyHxbetaB3"
              (NAVEL
               ("CyHxbetaA->amide3"
                (NAVEL
                 ("amide->CyHxbetaB3"
                  (NAVEL
                   ("CyHxbetaA->amide3"
                    (NAVEL
                     ("amide->CyHxbetaB3" (NAVEL CAP)))))))))))))) )
  
  (progn    ;; Expand out tree from Shorthand
    (dendro-plerogen 14-helix-tree)
    )
  )

;;;  (setf PDB-directory "MacPartition:PDB Reservoire 0.1")
;;(set-current-mlib-to 'primitive)
(get-current-tree)
(init-tree "Cubane-frame")
(init-tree "CyHxdelta")
(get-current-tree-volume)
(multiple-value-setq (actual-tree tree-symbol) (get-current-tree))
(attach-if-no-clash-p (get-current-tree) 1
                    (retrieve-from-mlib "cub1->amide1"))
(grow-one-moiety (random-pick (get-open-sites)))
(grow-a-tree)

(time
 (grow-a-bunch-of-trees 1000)
 )
(tree-rack-volumes)
(save-top-ten)
(save-top-ten :to 1)

(progn
  (time
   (grow-a-bunch-of-trees 100000)
   )
  (tree-rack-volumes)
  (save-top-ten)
  )

;; monitoring (= profiling)
(monitor:monitor grow-a-bunch-of-trees)
(monitor:monitor-all)
*monitored-functions*
(grow-a-bunch-of-trees 10)
(monitor:report-monitoring)
(monitor:display-monitoring-results)

(extract-clash-array)

(setf *print-level* nil)
(setf *print-level* 4)
(setf *print-level* 5)
(setf *print-circle* t)
(setf *print-circle* nil)
(save-object-in-file actual-tree "test")

(multiple-value-setq (tree-symbol actual-tree) (get-current-tree))

(progn    ;; Dump tree out in file
 ; (multiple-value-setq (actual-tree tree-symbol) (get-current-tree))
  (setf INCLUDE-FRAME t)
  (setf NO-INCLUDE-FRAME nil)
  (setf raw-format (dump-tree (get-current-tree) INCLUDE-FRAME))
  (write-pdb-file raw-format 
                  "newtree.pdb")
)

(progn    ;; Dump tree out in Shorthand
  (let ((*print-level* nil))
    (setf squeezed-out-tree (dendro-stenogen (get-current-tree)))
    (pprint squeezed-out-tree)
    )
)

(setf squeezed-out-tree
      '((FRAME "Cubane-frame")
        (("cub1->amide1"
          (NAVEL
           ("amide->CyHxgammaA1"
            (NAVEL
             ("CyHxgammaA->amide1"
              (NAVEL
               ("amide->CyHxdelta3"
                (NAVEL
                 ("CyHxdelta->amide1" (NAVEL CAP)))))))))))) )

(progn    ;; Expand out tree from Shorthand
  (dendro-plerogen squeezed-out-tree)
)

(write-pdb-file (generate-raw-format 
                 (generate-parsed-atm-vector
                  (moiety-type-atm-array sample-moiety-type))
                 (generate-parsed-bond-starlet-vector
                  (moiety-type-bond-array sample-moiety-type)))
                "xyz.pdb")

(write-pdb-file (generate-raw-format 
                 (generate-parsed-atm-vector
                  (moiety-atm-array (get-current-tree)))
                 '())
                "xyzcube.pdb")
(get-open-sites)
|#
#|
(dosequence (potential-trouble-maker
             (list
              "cub0->amide1"
              "cub0->amide2"
              "cub0->amide3"
              "cub1->amide1"
              "cub1->amide2"
              "cub1->amide3"
              "cub2->amide1"
              "cub2->amide2"
              "cub2->amide3"
              "cub3->amide1"
              "cub3->amide2"
              "cub3->amide3"
              )
             )
  (init-tree "Cubane-frame")
  (let ((link-type (retrieve-from-mlib potential-trouble-maker)))
    (attach-if-no-clash-p (get-current-tree)
                          (link-type-parent-site link-type)
                          link-type)
    )
  (setf INCLUDE-FRAME t)
  (setf raw-format (dump-tree (get-current-tree) INCLUDE-FRAME))
  (write-pdb-file raw-format 
                  (concatenate 'string
                               "xyz-"
                               potential-trouble-maker
                               ".pdb"))
  )
|#
#|
(progn
  (init-tree "Cubane-frame")
  (grow-one-moiety)
  (grow-one-moiety)
  (grow-one-moiety)
  (multiple-value-setq (tree-symbol actual-tree) (get-current-tree))
  (setf raw-format (dump-tree actual-tree t))
  (write-pdb-file raw-format 
                  "xyz7.pdb")
)
|#
#|
(set-current-mlib-to 'experimental)
(retrieve-from-mlib "norbornoxy")

(get-current-tree)

(init-tree "norbornoxy")
(get-current-tree-volume)

(multiple-value-setq (tree-symbol actual-tree) (get-current-tree))
(attach-if-no-clash actual-tree 0 0)
(setf *print-circle* t)
(save-object-in-file actual-tree "test")

(setf raw-format (dump-tree actual-tree t))
(write-pdb-file raw-format 
                "xyz.pdb")
(write-pdb-file (generate-raw-format 
                 (generate-parsed-atm-vector
                  (moiety-type-atm-array sample-moiety-type))
                 (generate-parsed-bond-starlet-vector
                  (moiety-type-bond-array sample-moiety-type)))
                "xyz.pdb")

|#

#| comes from an old file named "*library-usage".
;; demonstrates some moiety library construction.
(progn

  (init-mlib 'experimental)

  (progn
    (setf raw-format
          (read&parse-all-lines-of-a-file "norbornoxy.pdb" pdb-Chem3D+))
    (setf sample-moiety-type
          (create-moiety-type
           :name            "norbornoxy"
           :raw-format      raw-format
           :coordinate-atms '(6 7 3)
           :sites           '((0
                               (19)
                               (20 21 22 23)))
           ))
    (add-to-mlib sample-moiety-type)
    (print (moiety-type-name sample-moiety-type))
    )
  (progn
    (setf raw-format
          (read&parse-all-lines-of-a-file "tbutglycacid.pdb" pdb-Chem3D+))
    (setf sample-moiety-type
          (create-moiety-type
           :name            "tbutglycacid"
           :raw-format      raw-format
           :coordinate-atms '(1 2 3)
           :sites           '((0
                               (1)
                               (4 5 12 13 14)))
           ))
    (add-to-mlib sample-moiety-type)
    (print (moiety-type-name sample-moiety-type))
    )
  (progn
    (setf raw-format
          (read&parse-all-lines-of-a-file "lk-norbglyc.pdb" pdb-Chem3D+))
    (setf sample-link-type
          (create-link-type
           :parent-name       "norbornoxy"
           :parent-site       0
           :parent-bonds      '((19 (1)))
           :child-name        "tbutglycacid"
           :child-site        0
           :raw-format        raw-format
           :parent-coord-atms '(35 36 32)
           :child-coord-atms  '(1 2 3)
           :clash-atms        '()        
           ))
    (add-link-type-to-mlib sample-link-type)
    (print (link-type-name sample-link-type))
    )

    (save-mlib)
)

#|
(delete-link-type-from-mlib (retrieve-from-mlib "norbornoxy->tbutglycacid"))
(set-current-mlib-to 'experimental)
(retrieve-from-mlib "norbornoxy")
|#

;;;kr96-9-14
;;; try out VRML generation code
(setf raw-format
      (read&parse-all-lines-of-a-file "CyHx.pdb" pdb-Chem3D+))
(write-vrml-file raw-format "CyHx.wrl")
(setf raw-format
      (read&parse-all-lines-of-a-file "pdb1gcn.H.pdb" pdb-Chem3D+))
(write-vrml-file raw-format "pdb1gcn.H.wrl")
(prog
 (setf raw-format
       (read&parse-all-lines-of-a-file "four.H.pdb" pdb-Chem3D+))
 )
(write-vrml-file raw-format "four.H.wrl")
(prog
 (setf raw-format
       (read&parse-all-lines-of-a-file "planetaryGear.pdb" pdb-Chem3D+))
 )
(write-vrml-file raw-format "planetaryGear.wrl")

;;;kr96-10-30
(setf raw-format
      (parse-pdb-file "1sre.bonds.pdb" pdb-Chem3D+))
(setf raw-format
      (parse-pdb-file "test-cyhx.pdb" pdb-Chem3D+))

|#